/*******************************************************************************
 * FreeAdhocUDF - copyright (c) 2004 - 2010 adhoc dataservice GmbH
 * Christoph Theuring ct / Peter Mandrella pm / Georg Horn gh
 * <http://freeadhocudf.org> eMail <help@freeadhocudf.org>
 * (bug-)reports only in forum http://freeadhocudf.org/portal 
 * or eMail to help@freeadhocudf.org
 *   
 * this file contains declarations of string functions from FreeAdhocUDF
 *
 * if you use this declarations in a non UTF-8 or UNICODE_FSS database 
 *		the max lenght of CSTRING is 32766 (1 Byte per character)
 * if you use this declarations in a InterBase UNICODE_FSS database 
 *		the max lenght of CSTRING is 10922 (3 Byts per character)
 * if you use this declarations in a InterBase or FireBird UTF-8 database 
 *		the max lenght of CSTRING is 8191 (max 4 Byts per character)
 * All declarations in this file are set to CSTRING(8191)
 * if you want to use one UDF more times in one piped string or one SQL, 
 * the sum of CSTRING of the used UDF doesn't grow over the max of your database
 *
 * Functions in alphabetical order
 *
 * This file is part of FreeAdhocUDF.
 * FreeAdhocUDF is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * FreeAdhocUDF is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with FreeAdhocUDF.  If not, see <http://www.gnu.org/licenses/>. 
*******************************************************************************/

SET SQL DIALECT 3;

/******************************************************************************/
/****                   User Defined Functions - string functions          ****/
/****            use from FireBird 2.0 - possibility to return NULL        ****/
/******************************************************************************/

DECLARE EXTERNAL FUNCTION F_ANSILOWERCASE
    CSTRING(8191) NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'lower' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ANSIUPPERCASE
    CSTRING(8191) NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'upper' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BIGLEFT
    CSTRING(8191) NULL,
    INTEGER NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'left' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BIGLRTRIM
    CSTRING(8191) NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'lrtrim' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BIGLTRIM
    CSTRING(8191) NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'ltrim' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BIGMID
    CSTRING(8191) NULL,
    INTEGER NULL,
    INTEGER NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'mid' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BIGREPLACE
    CSTRING(8191) NULL,
    CSTRING(255) NULL,
    CSTRING(255) NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'replace' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BIGREPLACESTRING
    CSTRING(8191) NULL,
    CSTRING(255) NULL,
    CSTRING(255) NULL,
    INTEGER NULL,
    INTEGER NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'replacestring' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BIGRIGHT
    CSTRING(8191) NULL,
    INTEGER NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'right' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BIGRTRIM
    CSTRING(8191) NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'rtrim' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BIGSTRINGLENGTH
    CSTRING(8191) NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'stringlength' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BIGSTRIPSTRING
    CSTRING(8191) NULL,
    CSTRING(255) NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'stripstring' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BIGSTRIPSTRINGHOLD
    CSTRING(8191) NULL,
    CSTRING(255) NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'stripstringhold' MODULE_NAME 'FreeAdhocUDF';

/* Version compatible with Delphi FreeUDFLib
*  to use please uncomment it and comment the following version
* 
*DECLARE EXTERNAL FUNCTION F_BIGSUBSTR
*    CSTRING(255) NULL,
*    CSTRING(8191) NULL
*    RETURNS INTEGER FREE_IT
*    ENTRY_POINT 'strsub' MODULE_NAME 'FreeAdhocUDF';
*/ 

/* Version compatible with FreeUDFLibC */
DECLARE EXTERNAL FUNCTION F_BIGSUBSTR
    CSTRING(8191) NULL,
    CSTRING(255) NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'substr' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_CHARACTER
    INTEGER NULL
    RETURNS CSTRING(1) FREE_IT
    ENTRY_POINT 'character' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_CHR
    INTEGER NULL
    RETURNS CSTRING(1) FREE_IT
    ENTRY_POINT 'character' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_COLLATEBR
    CSTRING(8191) NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'collatebr' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_CONVERTSYMBOLS
    CSTRING(8191) NULL,
    CSTRING(255) NULL,
    CSTRING(255) NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'convertsymbols' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_COPY
    CSTRING(8191) NULL,
    INTEGER NULL,
    INTEGER NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'mid1' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_CRLF
    RETURNS CSTRING(3) FREE_IT
    ENTRY_POINT 'crlf' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_DIGITS
    CSTRING(8191) NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'digits' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_DOMAINFROMEMAIL
    CSTRING(255) NULL
    RETURNS CSTRING(255) FREE_IT
    ENTRY_POINT 'domainfromemail' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_DQM

    RETURNS CSTRING(2) FREE_IT
    ENTRY_POINT 'dqm' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_EQUALSTRING
    CSTRING(8191) NULL,
    CSTRING(8191) NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'equalstring' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_FINDNTHWORD
    CSTRING(8191) NULL,
    INTEGER NULL
    RETURNS CSTRING(255) FREE_IT
    ENTRY_POINT 'findnthword' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_FINDWORD
    CSTRING(8191) NULL,
    INTEGER NULL
    RETURNS CSTRING(255) FREE_IT
    ENTRY_POINT 'findword' MODULE_NAME 'FreeAdhocUDF';

/* version which returns -1 if not found 
*DECLARE EXTERNAL FUNCTION F_FINDWORDINDEX
*    CSTRING(8191) NULL,
*    INTEGER NULL
*    RETURNS INTEGER FREE_IT
*    ENTRY_POINT 'findwordindex' MODULE_NAME 'FreeAdhocUDF';
*/
/* version which returns <null> in FB 2.0 instead of -1 if not found */
DECLARE EXTERNAL FUNCTION F_FINDWORDINDEX
    CSTRING(8191) NULL,
    INTEGER NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'findwordindexnull' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_FLOATTOSTR
    DOUBLE PRECISION NULL,
    CSTRING(255) NULL
    RETURNS CSTRING(255) FREE_IT
    ENTRY_POINT 'floattostr' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_GENERATESNDXINDEX
    CSTRING(8191) NULL
    RETURNS CSTRING(6) FREE_IT
    ENTRY_POINT 'soundex' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_GSOUNDEX
    CSTRING(8191) NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'gsoundex' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_HOLDSTRING
    CSTRING(8191) NULL,
    CSTRING(255) NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'stripstringhold' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_INTTOSTR
    INTEGER NULL,
    CSTRING(255) NULL
    RETURNS CSTRING(255) FREE_IT
    ENTRY_POINT 'inttostr' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_KEYUP
    CSTRING(8191) NULL,
    SMALLINT NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'keyup' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_LEFT
    CSTRING(255) NULL,
    INTEGER NULL
    RETURNS CSTRING(255) FREE_IT
    ENTRY_POINT 'left' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_LEFT4
    CSTRING(4095) NULL,
    INTEGER NULL
    RETURNS CSTRING(4095) FREE_IT
    ENTRY_POINT 'left' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_LEFT8
    CSTRING(8191) NULL,
    INTEGER NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'left' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_LF
    RETURNS CSTRING(2) FREE_IT
    ENTRY_POINT 'lf' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_LINEWRAP
    CSTRING(8191) NULL,
    INTEGER NULL,
    INTEGER NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'linewrap' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_LOWER
    CSTRING(8191) NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'lower' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_LRTRIM
    CSTRING(255) NULL
    RETURNS CSTRING(255) FREE_IT
    ENTRY_POINT 'lrtrim' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_LRTRIM4
    CSTRING(4095) NULL
    RETURNS CSTRING(4095) FREE_IT
    ENTRY_POINT 'lrtrim' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_LRTRIM8
    CSTRING(8191) NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'lrtrim' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_LTRIM
    CSTRING(255) NULL
    RETURNS CSTRING(255) FREE_IT
    ENTRY_POINT 'ltrim' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_LTRIM4
    CSTRING(4095) NULL
    RETURNS CSTRING(4095) FREE_IT
    ENTRY_POINT 'lrtrim' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_LTRIM8
    CSTRING(8191) NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'lrtrim' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_MID
    CSTRING(255) NULL,
    INTEGER NULL,
    INTEGER NULL
    RETURNS CSTRING(255) FREE_IT
    ENTRY_POINT 'mid' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_MID4
    CSTRING(4095) NULL,
    INTEGER NULL,
    INTEGER NULL
    RETURNS CSTRING(4095) FREE_IT
    ENTRY_POINT 'mid' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_MID8
    CSTRING(8191) NULL,
    INTEGER NULL,
    INTEGER NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'mid' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_NBSP
    RETURNS CSTRING(2) FREE_IT
    ENTRY_POINT 'nbsp' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ORD
    CSTRING(1) NULL
    RETURNS SMALLINT FREE_IT
    ENTRY_POINT 'ord' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_PADCENTER
    CSTRING(4095) NULL,
    CSTRING(16) NULL,
    INTEGER NULL
    RETURNS CSTRING(4095) FREE_IT
    ENTRY_POINT 'padcenter' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_PADLEFT
    CSTRING(4095) NULL,
    CSTRING(16) NULL,
    INTEGER NULL
    RETURNS CSTRING(4095) FREE_IT
    ENTRY_POINT 'padleft' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_PADRIGHT
    CSTRING(4095) NULL,
    CSTRING(16) NULL,
    INTEGER NULL
    RETURNS CSTRING(4095) FREE_IT
    ENTRY_POINT 'padright' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_PRED
    CSTRING(1) NULL,
    INTEGER NULL
    RETURNS CSTRING(1) FREE_IT
    ENTRY_POINT 'predecessor' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_PROPERCASE
    CSTRING(8191) NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'propercase' MODULE_NAME 'FreeAdhocUDF';

/* this is correct WITHOUT NULL because of the sence of the function */
DECLARE EXTERNAL FUNCTION F_RC
    CSTRING(255)
    RETURNS CSTRING(255)
    ENTRY_POINT 'r_c' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_REPEATTRIM
    CSTRING(8191) NULL,
    CSTRING(1) NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'repeattrim' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_REPLACE
    CSTRING(255) NULL,
    CSTRING(255) NULL,
    CSTRING(255) NULL
    RETURNS CSTRING(255) FREE_IT
    ENTRY_POINT 'replace' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_REPLACE4
    CSTRING(4095) NULL,
    CSTRING(255) NULL,
    CSTRING(255) NULL
    RETURNS CSTRING(4095) FREE_IT
    ENTRY_POINT 'replace' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_REPLACE8
    CSTRING(8191) NULL,
    CSTRING(255) NULL,
    CSTRING(255) NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'replace' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_REPLACESTRING
    CSTRING(255) NULL,
    CSTRING(255) NULL,
    CSTRING(255) NULL,
    INTEGER NULL,
    INTEGER NULL
    RETURNS CSTRING(255) FREE_IT
    ENTRY_POINT 'replacestring' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_REPLACESTRING4
    CSTRING(4095) NULL,
    CSTRING(255) NULL,
    CSTRING(255) NULL,
    INTEGER NULL,
    INTEGER NULL
    RETURNS CSTRING(4095) FREE_IT
    ENTRY_POINT 'replacestring' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_REPLACESTRING8
    CSTRING(8191) NULL,
    CSTRING(255) NULL,
    CSTRING(255) NULL,
    INTEGER NULL,
    INTEGER NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'replacestring' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_REVERSE
    CSTRING(255) NULL
    RETURNS CSTRING(255) FREE_IT
    ENTRY_POINT 'reverse' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_RIGHT
    CSTRING(255) NULL,
    INTEGER NULL
    RETURNS CSTRING(255) FREE_IT
    ENTRY_POINT 'right' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_RIGHT4
    CSTRING(4095) NULL,
    INTEGER NULL
    RETURNS CSTRING(4095) FREE_IT
    ENTRY_POINT 'right' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_RIGHT8
    CSTRING(8191) NULL,
    INTEGER NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'right' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_RLATIN
    CSTRING(8191) NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'rlatin' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_RLOWER
    CSTRING(8191) NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'rlower' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ROT13
    CSTRING(255) NULL
    RETURNS CSTRING(255) FREE_IT
    ENTRY_POINT 'rot13' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_RPADLEFT
    CSTRING(4095) NULL,
    INTEGER NULL,
    CSTRING(16) NULL
    RETURNS CSTRING(4095) FREE_IT
    ENTRY_POINT 'r_padleft' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_RPADRIGHT
    CSTRING(4095) NULL,
    INTEGER NULL,
    CSTRING(16) NULL
    RETURNS CSTRING(4095) FREE_IT
    ENTRY_POINT 'r_padright' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_RSTRINGCOUNT
    CSTRING(255) NULL,
    CSTRING(8191) NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'r_stringcount' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_RTRIM
    CSTRING(255) NULL
    RETURNS CSTRING(255) FREE_IT
    ENTRY_POINT 'rtrim' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_RTRIM4
    CSTRING(4095) NULL
    RETURNS CSTRING(4095) FREE_IT
    ENTRY_POINT 'lrtrim' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_RTRIM8
    CSTRING(8191) NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'lrtrim' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_RUPPER
    CSTRING(8191) NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'rupper' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_RWORDCOUNT
    CSTRING(8191) NULL,
    CSTRING(31) NULL,
    SMALLINT NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'r_wordcount' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_SOUNDEX
    CSTRING(8191) NULL
    RETURNS CSTRING(6) FREE_IT
    ENTRY_POINT 'soundex' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_SPACE
    INTEGER NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'space' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_SQM
    RETURNS CSTRING(2) FREE_IT
    ENTRY_POINT 'sqm' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_STR2EXCEL
    CSTRING(8191) NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'excelstring' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_STRCMP
    CSTRING(8191) NULL,
    CSTRING(8191) NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'r_strcmp' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_STRCOPY
    CSTRING(8191) NULL,
    INTEGER NULL,
    INTEGER NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'strcopy' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_STRINGCOUNT
    CSTRING(8191) NULL,
    CSTRING(255) NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'stringcount' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_STRINGLENGTH
    CSTRING(255) NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'stringlength' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_STRINGLENGTH4
    CSTRING(4095) NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'stringlength' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_STRINGLENGTH8
    CSTRING(8191) NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'stringlength' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_STRINGLISTITEM
    CSTRING(8191) NULL,
    CSTRING(255) NULL
    RETURNS CSTRING(1024) FREE_IT
    ENTRY_POINT 'stringlistitem' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_STRIPSTRING
    CSTRING(255) NULL,
    CSTRING(255) NULL
    RETURNS CSTRING(255) FREE_IT
    ENTRY_POINT 'stripstring' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_STRIPSTRING4
    CSTRING(4095) NULL,
    CSTRING(255) NULL
    RETURNS CSTRING(4095) FREE_IT
    ENTRY_POINT 'stripstring' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_STRIPSTRING8
    CSTRING(8191) NULL,
    CSTRING(255) NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'stripstring' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_STRIPSTRINGHOLD
    CSTRING(255) NULL,
    CSTRING(255) NULL
    RETURNS CSTRING(255) FREE_IT
    ENTRY_POINT 'stripstringhold' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_STRIPSTRINGHOLD4
    CSTRING(4095) NULL,
    CSTRING(255) NULL
    RETURNS CSTRING(4095) FREE_IT
    ENTRY_POINT 'stripstringhold' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_STRIPSTRINGHOLD8
    CSTRING(8191) NULL,
    CSTRING(255) NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'stripstringhold' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_STROFCHAR
    CSTRING(1) NULL,
    INTEGER NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'strofchar' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_STRPOS
    CSTRING(255) NULL,
    CSTRING(8191) NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'strpos' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_STRREPEAT
    CSTRING(255) NULL,
    SMALLINT NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'strrepeat' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_STRRM
    CSTRING(8191) NULL,
    INTEGER NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'strrm' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_STRSTUFF
    CSTRING(8191) NULL,
    SMALLINT NULL,
    SMALLINT NULL,
    CSTRING(255) NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'strstuff' MODULE_NAME 'FreeAdhocUDF';

/* Version compatible with Delphi FreeUDFLib
*  to use please uncomment it and comment the following version
* 
*DECLARE EXTERNAL FUNCTION F_SUBSTR
*    CSTRING(255) NULL,
*    CSTRING(255) NULL
*    RETURNS INTEGER FREE_IT
*    ENTRY_POINT 'strsub' MODULE_NAME 'FreeAdhocUDF';
*/

/* Version compatible with Delphi FreeUDFLib and NULL
*  to use please uncomment it and comment the following version
* 
*DECLARE EXTERNAL FUNCTION F_SUBSTR
*    CSTRING(255) NULL,
*    CSTRING(255) NULL
*    RETURNS INTEGER FREE_IT
*    ENTRY_POINT 'strsubnull' MODULE_NAME 'FreeAdhocUDF';
*/

/* Version compatible with FreeUDFLibC 
*  to use please uncomment it and comment the following version
*DECLARE EXTERNAL FUNCTION F_SUBSTR
*    CSTRING(255) NULL,
*    CSTRING(255) NULL
*    RETURNS INTEGER FREE_IT
*    ENTRY_POINT 'substr' MODULE_NAME 'FreeAdhocUDF';
*/

/* Version compatible with FreeUDFLibC and NULL */
DECLARE EXTERNAL FUNCTION F_SUBSTR
    CSTRING(255) NULL,
    CSTRING(255) NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'substrnull' MODULE_NAME 'FreeAdhocUDF';

/* Version compatible with FreeUDFLibC and NULL */
DECLARE EXTERNAL FUNCTION F_SUBSTR4
    CSTRING(4095) NULL,
    CSTRING(255) NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'substrnull' MODULE_NAME 'FreeAdhocUDF';

/* Version compatible with FreeUDFLibC and NULL */
DECLARE EXTERNAL FUNCTION F_SUBSTR8
    CSTRING(8191) NULL,
    CSTRING(255) NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'substrnull' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_SUCC
    CSTRING(1) NULL,
    INTEGER NULL
    RETURNS CSTRING(1) FREE_IT
    ENTRY_POINT 'successor' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_TAB
    RETURNS CSTRING(2) FREE_IT
    ENTRY_POINT 'tab' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_TELEFONNR
    CSTRING(8191) NULL,
    INTEGER NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'telefonnr' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_UPPER
    CSTRING(8191) NULL
    RETURNS CSTRING(8191) FREE_IT
    ENTRY_POINT 'upper' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_WORDCOUNT
    CSTRING(8191) NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'wordcount' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_WORDNUM
    CSTRING(8191) NULL,
    INTEGER NULL,
    CSTRING(31) NULL,
    SMALLINT NULL
    RETURNS CSTRING(255) FREE_IT
    ENTRY_POINT 'wordnum' MODULE_NAME 'FreeAdhocUDF';

/* adhoc 2009-09-21 */

DECLARE EXTERNAL FUNCTION F_DSQM
    RETURNS CSTRING(3) FREE_IT
    ENTRY_POINT 'dsqm' MODULE_NAME 'FreeAdhocUDF';
    
/* adhoc 2010-11-09 */    
